//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Voltmeter with 4x7 segment LED display
//DO NOT TOUCH VOLTAGES ABOVE +5V WITH THE PROBE !!!!!

//Pins when looking at the FRONT side of the 4x7 segment display
//Top row from left to right:
//Pin 1 to Arduino pin 2 through 220 ohms resistor
//Pin 2 to Arduino pin 6
//Pin 3 to Arduino pin 11
//Pin 4 to Arduino pin 3 through 220 ohms resistor
//Pin 5 to Arduino pin 4 through 220 ohms resistor
//Pin 6 to Arduino pin 7

//Bottom row from left to right:
//Pin 1 to Arduino pin 10
//Pin 2 to Arduino pin 9
//Pin 3 to Arduino pin 13
//Pin 4 to Arduino pin 8
//Pin 5 to Arduino pin 12
//Pin 6 to Arduino pin 5 through 220 ohms resistor

//1 kiloohm resistor between A0 and GND, voltmeter probe connected to A0

#include "SevSeg.h"

#define CHANNEL_1_PIN   A0

SevSeg sevseg; //Initiate a seven segment controller object
long ADCval_01;
unsigned long refreshInterval;

void setup() {
  byte numDigits = 4;
  byte digitPins[] = {2, 3, 4, 5};
  byte segmentPins[] = {6, 7, 8, 9, 10, 11, 12, 13};
  sevseg.begin(COMMON_CATHODE, numDigits, digitPins, segmentPins);
  sevseg.setBrightness(90);

  refreshInterval = 0;
}

void loop(){
  if(millis() - refreshInterval > 500){
    ADCval_01 = analogRead(CHANNEL_1_PIN);
    ADCval_01 = 5 * ADCval_01 * 1000 / 1023;
    sevseg.setNumber(ADCval_01, 3);
    refreshInterval = millis();
  }
  sevseg.refreshDisplay(); // Must run repeatedly
}
